# Image search

Step 1: POST `/vectorize-image`

This endpoint lets you to create a vectorization id for an image by providing a base64 encoded string of the image.

Note: If you want to detect specific objects in an image before starting the image search process, you want to use the [/detect-objects](/search/detect-objects.md) endpoint.

**Headers**

| Header          | Type   | Description   |
| --------------- | ------ | ------------- |
| `Authorization` | string | Bearer token. |

**Request body**

The request passes the base64 encoded string of the image you want to use.

```json
{
    "base64String": "string"
}
```

**Response**

{% tabs %}
{% tab title="200" %}

```json
{
  "status": "success",
  "slug": "newRequest.slug"
}
```

{% endtab %}

{% tab title="500" %}

```json
{
 "status": "error",
 "message": "Internal Server Error"
}
```

{% endtab %}
{% endtabs %}

Step 2: GET `/search`

This endpoint lets you to search products that match the image.

**Headers**

| Header          | Type   | Description  |
| --------------- | ------ | ------------ |
| `Authorization` | string | Bearer token |

**Query parameters**

| Parameter | Type   | Description              |
| --------- | ------ | ------------------------ |
| `imageId` | string | Image search identifier. |

**Response**

{% tabs %}
{% tab title="200" %}

```json
{
  "status": "success",
  "Products": [
        {
            "_id": "65d4d4f1b7bb634c6599ffd2",
            "name": "Calzuro Classic Without Holes Pistachio",
            "brand": "Calzuro",
            "storeName": "Calzuro",
            "slug": "calzuro-without-pistachio-eb12f468-48a2-48af-9f5e-3fda5f6c135c-1708446961787",
            "price": 111.99,
            "isVerified": true,
            "isBoosted": false,
            "images": [
                "https://cdn.shopify.com/s/files/1/0738/4442/4986/products/pistachio-calzuro-without-1.jpg?v=1682709875",
                "https://cdn.shopify.com/s/files/1/0738/4442/4986/files/pistachiocalzuro.png?v=1712343485",
                "https://cdn.shopify.com/s/files/1/0738/4442/4986/files/classicinfographic_26486960-c007-4661-b74d-b50e158115cc.png?v=1712343485",
                "https://cdn.shopify.com/s/files/1/0738/4442/4986/products/pistachio-calzuro-without-2.jpg?v=1712343483",
                "https://cdn.shopify.com/s/files/1/0738/4442/4986/products/pistachio-calzuro-without-3.jpg?v=1712343483",
                "https://cdn.shopify.com/s/files/1/0738/4442/4986/products/pistachio-calzuro-without-4.jpg?v=1712343483"
            ],
            "url": "https://calzuro.com/products/calzuro-without-pistachio",
            "agoraScore": 95,
            "priceHistory": [
                {
                    "price": 111.99,
                    "date": "2024-02-20T16:36:01.992Z",
                    "_id": "671499c36ca0a1804aca445f"
                }
            ],
            "discountVal": 0,
            "averageRating": 4.5
        }
    ]
}
```

{% endtab %}

{% tab title="500" %}

```
{
 "status": "error",
 "message": "Internal Server Error"
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.searchagora.com/search/image-search.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
